local ctfade                    = true
local cfade                     = true
local uinoticea                 = true
local uinoticeb                 = true
local csounds                   = true
local altclickinvite            = true
local eboxbottom                = false
local arrows                    = true
local Emote                     = "Hide"
local Friends                   = "Hide"
local outline                   = false

--[[-----------------------------------------------------------------------------

Setting descriptions:

ctfade/cfade
	ctfade = Chat Tab, Set to false to have the Chat Tab not Fade out.
	cfade  = Chat Font, Set to true to have the Chat Font not Fade out.

uinoticea/uinoticeb
	Uinoticea = Error notification frame, Set to false to turn off.
        (WTS,WTB,LF,LFG,LFM.)
	Uinoticeb = Error notification frame, Set to false to turn off.
        (You have been outbid,group has been disbanded,instance will reset)

csounds
	Chat Sounds, Set to false to turn off.

altclickinvite
	Alt click invite to party, Set to false to turn off.
        (hold alt and left click to invite from the chat)

eboxbottom
	To have the editbox show at the bottom, Set to false to turn off.

arrows
	Set to false to see the Arrows icon.

Emote
	Set to Show to see the Emote icon.

Friends
	Set to Show to see the Friends icon.

outline
	Set to true to have the Chat text bold.

-------------------------------------------------------------------------------]]

--Code Starts--

--Justify --"LEFT","RIGHT", or "CENTER" ChatFrames 1 - 10 
ChatFrame2:SetJustifyH("RIGHT")
--(combatlog) 2,RIGHT 

--Timestamp
TIMESTAMP_FORMAT_HHMM = "|r|cff777777[%I:%M]|r "
TIMESTAMP_FORMAT_HHMM_24HR = "|r|cff777777[%H:%M]|r "
TIMESTAMP_FORMAT_HHMM_AMPM = "|r|cff777777[%I:%M %p]|r "

TIMESTAMP_FORMAT_HHMMSS = "|r|cff777777[%I:%M:%S]|r "
TIMESTAMP_FORMAT_HHMMSS_24HR = "|r|cff777777[%H:%M:%S]|r "
TIMESTAMP_FORMAT_HHMMSS_AMPM = "|r|cff777777[%I:%M:%S %p]|r "

--Chat Tab Fade.
if ctfade then
	CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0
	CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 0
	CHAT_FRAME_BUTTON_FRAME_MIN_ALPHA = 0
	for i=1, 10 do
		local tab = _G[format("%s%d%s", "ChatFrame", i, "Tab")]
		tab:SetAlpha(0)
		tab.noMouseAlpha = 0
	end
end

--Chat Font Fade.
if cfade then
for i = 1, 10 do
    local cf = _G["ChatFrame"..i]
    cf:SetFading(false)
end
end

--Sticky Channels, 0 off, 1 on
ChatTypeInfo.EMOTE.sticky = 1
ChatTypeInfo.YELL.sticky = 1
ChatTypeInfo.RAID_WARNING.sticky = 1

--If you want to unsticky whispers or BNet whispers, remove the "--" on the following lines
--ChatTypeInfo.WHISPER.sticky = 0
--ChatTypeInfo.BN_WHISPER.sticky = 0

--Short channel names
CHAT_BATTLEGROUND_GET = "BG %s: "
CHAT_BATTLEGROUND_LEADER_GET = "BGL: %s "
CHAT_SAY_GET = "%s: "
CHAT_YELL_GET = "%s: "
CHAT_WHISPER_GET = "F %s: "
CHAT_WHISPER_INFORM_GET = "T %s: "
CHAT_GUILD_GET = "G %s: "
CHAT_OFFICER_GET = "O %s: "
CHAT_PARTY_GET = "P %s: "
CHAT_PARTY_LEADER_GET = "PL %s: "
CHAT_PARTY_GUIDE_GET = "DG %s: "
CHAT_RAID_GET = "R %s: "
CHAT_RAID_LEADER_GET = "RL %s: "
CHAT_RAID_WARNING_GET = "RW %s: "

local gsub = _G.string.gsub
local time = _G.time
local newAddMsg = {}
local chn, rplc
	rplc = {
		"[GEN]", --General
		"[T]", --Trade
		"[WD]", --WorldDefense
		"[LD]", --LocalDefense
		"[LFG]", --LookingForGroup
		"[GR]", --GuildRecruitment
	}

		chn = {
			"%[%d+%. General.-%]",
			"%[%d+%. Trade.-%]",
			"%[%d+%. WorldDefense%]",
			"%[%d+%. LocalDefense.-%]",
			"%[%d+%. LookingForGroup%]",
			"%[%d+%. GuildRecruitment.-%]",
		}

local function AddMessage(frame, text, ...)
	for i = 1, 6 do
		text = gsub(text, chn[i], rplc[i])
	end

	--If Blizz timestamps is enabled, stamp anything it misses
	if CHAT_TIMESTAMP_FORMAT and not text:find("^|r") then
		text = BetterDate(CHAT_TIMESTAMP_FORMAT, time())..text
	end
	text = gsub(text, "%[(%d0?)%. .-%]", "[%1]") --custom channels
	return newAddMsg[frame:GetName()](frame, text, ...)
end

	for i = 1, 5 do
		if i ~= 2 then -- skip combatlog
			local ch = _G[format("%s%d", "ChatFrame", i)]
			newAddMsg[format("%s%d", "ChatFrame", i)] = ch.AddMessage
			ch.AddMessage = AddMessage
		end
	end

--Scrolldown
function FloatingChatFrame_OnMouseScroll(self, delta)
	if delta < 0 then
		if IsShiftKeyDown() then self:ScrollToBottom()
		else
			for i = 1, 3 do self:ScrollDown() end end
	elseif delta > 0 then
		if IsShiftKeyDown() then self:ScrollToTop()
		else
			for i = 1, 3 do self:ScrollUp()
			end
		end
	end
end

--Buttons
ChatFrameMenuButton[Emote](ChatFrameMenuButton)
ChatFrameMenuButton.Show = function() end
FriendsMicroButton[Friends](FriendsMicroButton)
FriendsMicroButton.Show = function() end
--Real ID Frame
BNToastFrame:SetClampedToScreen(true)

if arrows then
	local hideFunc = function(frame) frame:Hide() end
	for i = 1, 10 do
		local ab = _G[format("%s%d%s", "ChatFrame", i, "ButtonFrame")]
		ab:SetScript("OnShow", hideFunc)
		ab:Hide()
	end
end

--misc functions (Frame size/move,Arrow keys,editbox to the top) 
	for i = 1, 10 do
		local eb =  _G[format("%s%d%s", "ChatFrame", i, "EditBox")]
		local cfs = _G[format("%s%d", "ChatFrame", i)]
		cfs:SetMinResize(0,0)
		cfs:SetMaxResize(0,0)
                cfs:SetClampRectInsets(0,0,0,0)
		eb:SetAltArrowKeyMode(false)
if outline then 
cfs:SetFont([[FONTS\FRIZQT__.ttf]], 13, "OUTLINE") 
end
if eboxbottom then
		eb:ClearAllPoints()
		eb:SetPoint("TOPLEFT",  cfs, "BOTTOMLEFT",  -5, 0)
		eb:SetPoint("TOPRIGHT", cfs, "BOTTOMRIGHT", 5, 0)
else
		eb:ClearAllPoints()
		eb:SetPoint("BOTTOMLEFT",  cfs, "TOPLEFT",  -5, 0)
		eb:SetPoint("BOTTOMRIGHT", cfs, "TOPRIGHT", 5, 0)
	end
end

--noticea
if uinoticea then
local cnot = CreateFrame("Frame")
cnot:RegisterEvent("CHAT_MSG_CHANNEL")
cnot:SetScript("OnEvent", function(self, event, arg1, arg2)
		if string.find(arg1, "WTS%s.*") then
			UIErrorsFrame:AddMessage("|cFFFF0000WTS: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "WTB%s.*") then
			UIErrorsFrame:AddMessage("|cFF0000FFWTB: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "LF%s.*") then
			UIErrorsFrame:AddMessage("|cFF00FF00LFG: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "LFG%s.*") then
			UIErrorsFrame:AddMessage("|cFF00FF00LFG: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "LFM%s.*") then
			UIErrorsFrame:AddMessage("|cFF00FF00LFM: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
     end
end)
end

--noticeb
if uinoticeb then
local c2not = CreateFrame("Frame")
c2not:RegisterEvent("CHAT_MSG_CHANNEL")
c2not:SetScript("OnEvent", function(self, event, arg1, arg2)
		if string.find(arg1, "A buyer has been found for your auction of .+%.") then
			UIErrorsFrame:AddMessage(arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
			PlaySound("MapPing")
		end
		if string.find(arg1, "You have been outbid on .+ sold%.") then
			UIErrorsFrame:AddMessage(arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
			PlaySound("MapPing")
		end
		if string.find(arg1, "Your group has been disbanded.") then
			UIErrorsFrame:AddMessage(arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
			PlaySound("MapPing")
		end
		if string.find(arg1, "This instance will reset in .+%.") then
			UIErrorsFrame:AddMessage(arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
			PlaySound("MapPing")
		end
end)
end

--URL Copy
local color = "C0C0C0"
local pattern = "[wWhH][wWtT][wWtT][\46pP]%S+[^%p%s]"

function string.color(text, color)
	return "|cff"..color..text.."|r"
end

function string.link(text, type, value, color)
	return "|H"..type..":"..tostring(value).."|h"..tostring(text):color(color or "ffffff").."|h"
end

StaticPopupDialogs["LINKME"] = {
	text = "URL COPY",
	button2 = CANCEL,
	hasEditBox = true,
    hasWideEditBox = true,
	timeout = 0,
	exclusive = 1,
	hideOnEscape = 1,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
	whileDead = 1,
	maxLetters = 255,
}

local function f(url)
	return string.link("["..url.."]", "url", url, color)
end

local function hook(self, text, ...)
	self:f(text:gsub(pattern, f), ...)
end

function LinkMeURL()
	for i = 1, NUM_CHAT_WINDOWS do
		if ( i ~= 2 ) then
			local lframe = _G["ChatFrame"..i]
			lframe.f = lframe.AddMessage
			lframe.AddMessage = hook
		end
	end
end
LinkMeURL()

local ur = ChatFrame_OnHyperlinkShow
function ChatFrame_OnHyperlinkShow(self, link, text, button)
	local type, value = link:match("(%a+):(.+)")
	if ( type == "url" ) then
		local dialog = StaticPopup_Show("LINKME")
		local editbox1 = _G[dialog:GetName().."WideEditBox"]  
		editbox1:SetText(value)
		editbox1:SetFocus()
		editbox1:HighlightText()
		local button = _G[dialog:GetName().."Button2"]
            
		button:ClearAllPoints()
           
		button:SetPoint("CENTER", editbox1, "CENTER", 0, -30)
	else
		ur(self, link, text, button)
	end
end

--Chat copy
local frame = CreateFrame("Frame", "CopyFrame", UIParent)
frame:SetBackdrop({
	bgFile = "Interface\\AddOns\\wChat\\media\\UI-DialogBox-Background.blp",
	edgeFile = "Interface\\AddOns\\wChat\\media\\UI-DialogBox-Border.blp",
	tile = true, tileSize = 16, edgeSize = 16,
	insets = {left = 3, right = 3, top = 5, bottom = 3
}})

frame:SetBackdropColor(0, 0, 0, 1)
frame:SetWidth(500)
frame:SetHeight(400)
frame:SetPoint("LEFT", UIParent, "LEFT", 3, 10)
frame:SetFrameStrata("DIALOG")
frame:Hide()

local scrollArea = CreateFrame("ScrollFrame", "CopyFrameScroll", frame, "UIPanelScrollFrameTemplate")
scrollArea:SetPoint("TOPLEFT", frame, "TOPLEFT", 8, -30)
scrollArea:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -30, 8)

local editBox = CreateFrame("EditBox", "CopyBox", frame)
editBox:SetMultiLine(true)
editBox:SetMaxLetters(20000)
editBox:EnableMouse(true)
editBox:SetAutoFocus(true)
editBox:SetFontObject(ChatFontNormal)
editBox:SetWidth(450)
editBox:SetHeight(270)
editBox:SetScript("OnEscapePressed", function() frame:Hide() end)

scrollArea:SetScrollChild(editBox)

local close = CreateFrame("Button", "CopyClose", frame, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -1)

local lines = {}
local getLines = function(...)
	local count = 1

	for i = select("#", ...), 1, -1 do
		local region = select(i, ...)
		
		if region:GetObjectType() == "FontString" then
			lines[count] = tostring(region:GetText())
			count = count + 1
		end
	end

	return count - 1
end

local copyChat = function(self, chatTab)
	local chatFrame = _G["ChatFrame" .. chatTab:GetID()]
	local _, fontSize = chatFrame:GetFont()
	
	FCF_SetChatWindowFontSize(chatFrame, chatFrame, 0.01)
	
	local lineCount = getLines(chatFrame:GetRegions())
	
	FCF_SetChatWindowFontSize(chatFrame, chatFrame, fontSize)

	if lineCount > 0 then
		local text = table.concat(lines, "\n", 1, lineCount)

		frame:Show()
		editBox:SetText(text)
	end
end

local info = {
	text = "Copy Chat Contents",
	func = copyChat,
	notCheckable = 1	
}

local origFCF_Tab_OnClick = _G.FCF_Tab_OnClick
local FCF_Tab_OnClickHook = function(chatTab, ...)
	origFCF_Tab_OnClick(chatTab, ...)

	info.arg1 = chatTab
	
	UIDropDownMenu_AddButton(info)
end

FCF_Tab_OnClick = FCF_Tab_OnClickHook

--Chat Sounds
if csounds then
local name, ns = ...
local mediaPath = [=[Interface\AddOns\wChat\media\]=]
local name = UnitName'player'
local evtsounds = {
	["CHAT_MSG_GUILD"] = "Kachink",
	["CHAT_MSG_OFFICER"] = "Link",
	["CHAT_MSG_PARTY"] = "pop1",
	["CHAT_MSG_PARTY_LEADER"] = "pop2",
	["CHAT_MSG_RAID"] = "Text2",
	["CHAT_MSG_WHISPER"] = "Heart",
	["CHAT_MSG_GMWHISPER"] = "gasp",
	["CHAT_MSG_RAID_LEADER"] = "Choo",
	["CHAT_MSG_BATTLEGROUND"] = "switchy",
	["CHAT_MSG_BATTLEGROUND_LEADER"] = "doublehit",
	["CHAT_MSG_CHANNEL"] = true, --dummy
}

local cs = CreateFrame'Frame'
cs:SetScript('OnEvent', function(self, event, ...)
	local msg, author, lang, channel = ...
	if author == name then return end
	if event == "CHAT_MSG_CHANNEL" then
		-- TODO
	else
		local sound = mediaPath..evtsounds[event]..'.wav'
		PlaySoundFile(sound)
	end
end)

for event, sound in pairs(evtsounds) do
	cs:RegisterEvent(event)
   end
end

--Alt click invite.
if altclickinvite then
local origSetItemRef = SetItemRef
SetItemRef = function(link, text, button)
	local linkType = string.sub(link, 1, 6)
	if IsAltKeyDown() and linkType == "player" then
		local aname = string.match(link, "player:([^:]+)")
		InviteUnit(aname)
		return nil
	end
	return origSetItemRef(link,text,button)
   end
end

print("|cff3399FFw|rChat: Loaded|r");